\begin{exercise}{3.2}
   \begin{figure}[h]
    \centering
    \begin{subfigure}{0.5\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex2/mse.pdf}
      \caption{}
    \end{subfigure}\hfil
    \begin{subfigure}{0.5\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex2/r2.pdf}
      \caption{}
    \end{subfigure}
    \caption{plots of mean squared error (a) and $R^2$ (b) for all possible subsets of features, divided on number of features used. The path of forward and backward selection is highlighted.}
    \label{fig:3.2}
  \end{figure}
   
   I've chosen the \texttt{MEDV} value as output, and I've run a \texttt{LinearRegression()} on every possible set of features. The result are plotted in the Figure~\ref{fig:3.2}. We note that both the selection achieves nearly optimal performance on any number of features, so we can conclude that these methods are good model reductions that can be used when we can't afford all subset selection.
  
  \pythoncode{\RootPathSheetThree/ex2/code.py}
\end{exercise}